<template>
  <div class="card mb-3" v-if="product">
    <div class="card-header">
      {{ product.productName }}
    </div>

    <div class="row no-gutters">
      <div class="col-md-4">
        <img :src="`http://localhost:5000/uploads/${product.photo}`"
             class="card-img" alt=""/>
      </div>
      <div class="col-md-8">
        <div class="card-body">
          <h5 class="card-title">Product Name: {{ product.productName }}</h5>
          <p class="card-text">{{ product.description }}</p>
          <p class="card-text">Rs. {{ product.price }}</p>
          <form class="form-group" @submit.prevent="addItemsToCart()">
            <label for="quantity">Quantity</label>
            <input type="number" id="quantity"
                   min="1"
                   class="form-control w-25"
                   :class="{'is-invalid': $v.quantity.$error}"
                   v-model="quantity"/>
            <span class="invalid-feedback">
                            <span v-if="$v.quantity.minVal">
                                Quantity must be 1 or greater than 1.
                            </span>
                        </span>
            <button class="btn btn-primary"
                    type="submit"
                    style="width:150px; margin-top: 20px">
              Add to Cart <i class="fa fa-shopping-cart"></i>
            </button>
          </form>
          <p class="card-text"><small class="text-muted">{{ product.timestamp._seconds | dateAgo }}</small></p>
          <button class="btn btn-outline-secondary mr-3"
                  style="width:80px" @click="goBack">
            <i class="fa fa-chevron-left"></i> Back
          </button>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import {minValue} from 'vuelidate/lib/validators';

export default {
  data() {
    return {
      product: null,
      quantity: 1
    }
  },
  validations: {
    quantity: {
      minVal: minValue(1)
    }
  },
  created() {
     this.product = this.$route.meta.product;
  },
  methods: {
    goBack() {
      this.$router.replace('/shop');
    },
    addItemsToCart() {
      this.$v.$touch();
      let data = {
        id: this.product.id,
        productName: this.product.productName,
        price: +this.product.price,
        quantity: +this.quantity
      };
      this.$store.dispatch('addItems', data);
    }
  },
  computed: {
    items() {
      return this.$store.getters.itemsInCart;
    }
  }
}
</script>
